#include <string.h>
#include "dialoghi.h"
#include "support.h"
#include "rubrica.h"

const gchar *autore[] = {
  "Nicola Fragale <nicolafragale@libero.it>",
  NULL
};

/*
  DIALOGHI
*/

void Calabria(void)
{
  GtkWidget *calabria_dlg;
  GtkWidget *dialog_calabria;
  GtkWidget *frame_calabria;
  GtkWidget *box_calabria;
  GtkWidget *pix_calabria;
  GtkWidget *vseparator;
  GtkWidget *repaci;
  GtkWidget *box_calabria_bt;
  GtkWidget *calabria_ok_bt;

  calabria_dlg = gnome_dialog_new (_("La Calabria "), NULL);
  
  gtk_container_set_border_width (GTK_CONTAINER (calabria_dlg), 5);
  GTK_WINDOW (calabria_dlg)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (calabria_dlg), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (calabria_dlg), TRUE, FALSE, FALSE);

  dialog_calabria = GNOME_DIALOG (calabria_dlg)->vbox;

  frame_calabria = gtk_frame_new (_(" La Calabria "));

  gtk_widget_show (frame_calabria);
  gtk_box_pack_start (GTK_BOX (dialog_calabria), 
		      frame_calabria, TRUE, TRUE, 0);

  box_calabria = gtk_hbox_new (FALSE, 10);

  gtk_widget_show (box_calabria);
  gtk_container_add (GTK_CONTAINER (frame_calabria), box_calabria);
  gtk_container_set_border_width (GTK_CONTAINER (box_calabria), 10);

  /* path per la pixmap calabria 
  */
  pix_calabria = create_pixmap (calabria_dlg, "./pixmaps/calabria.xpm", FALSE);

  gtk_widget_show (pix_calabria);
  gtk_box_pack_start (GTK_BOX (box_calabria), pix_calabria, TRUE, TRUE, 0);
  gtk_pixmap_set_build_insensitive (GTK_PIXMAP (pix_calabria), FALSE);

  vseparator = gtk_vseparator_new ();

  gtk_widget_show (vseparator);
  gtk_box_pack_start (GTK_BOX (box_calabria), vseparator, TRUE, TRUE, 2);

  repaci = gtk_label_new (_("\"\nQuando fu il giorno della Calabria, Dio si trov in pugno 15.000 chilometri quadrati di argilla verde con riflessi viola.\nIl Signore promise a se stesso di farne un capolavoro e la Calabria usc dalle Sue mani pi bella della California e delle Haway, pi bella della Costa Azzurra e degli Arcipelaghi giapponesi. Diede alla Sila il pino, all'Aspromonte l'ulivo, a Rosarno l'arancio, A Scilla le Sirene, a Bagnara i pergolati, allo scoglio il lichene, all'onda il riflesso del sole, alla roccia l'oleastro, a Gioia l'olio, a Cosenza l'Accademia, a Catanzaro il damasco, a Reggio il bergamotto, allo Stretto il pescespada. Poi distribu i mesi e le stagioni alla Calabria. Per l'inverno le fu concesso il sole, per la primavera il sole, per l'autunno il sole...\nA gennaio diede la castagna, a febraio la pignolata, a marzo la ricotta, ad aprile la focaccia con l'uovo, a maggio il pescespada, a giugno la ciliegia, a luglio il ficomelanzano, ad agosto lo zibibbo, a settembre il ficodindia, ad ottobre la mostarda, a novembre la noce, a dicembre l'arancia. Volle il mare sempre viola, la rosa sbocciante a dicembre, il cielo terso, le campagne fertili, le messi pingui, il clima mite, il profumo delle erbe inebriante...\n                                                                     \"\n\n                                                Leonida Rpaci"));


  gtk_widget_show (repaci);
  gtk_box_pack_start (GTK_BOX (box_calabria), repaci, TRUE, TRUE, 2);
  gtk_label_set_justify (GTK_LABEL (repaci), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (repaci), TRUE);

  box_calabria_bt = GNOME_DIALOG (calabria_dlg)->action_area;


  gtk_widget_show (box_calabria_bt);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (box_calabria_bt), 
			     GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (box_calabria_bt), 8);

  gnome_dialog_append_button (GNOME_DIALOG (calabria_dlg), 
			      GNOME_STOCK_BUTTON_OK);
  calabria_ok_bt = g_list_last (GNOME_DIALOG (calabria_dlg)->buttons)->data;

  gtk_widget_show (calabria_ok_bt);
  GTK_WIDGET_SET_FLAGS (calabria_ok_bt, GTK_CAN_DEFAULT);

  gtk_signal_connect_object (GTK_OBJECT (calabria_ok_bt), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_hide),
                             GTK_OBJECT (calabria_dlg));

  gtk_widget_show(calabria_dlg);
}

void Dedica(void)
{
  GtkWidget *dedica_dlg;
  GtkWidget *dialog_dedica;
  GtkWidget *frame_dedica;
  GtkWidget *box_dedica_dati;
  GtkWidget *pix_dedica;
  GtkWidget *vseparator;
  GtkWidget *dedica;
  GtkWidget *box_dialog_bt;
  GtkWidget *dedica_ok_bt;

  dedica_dlg = gnome_dialog_new (_("Dedica"), NULL);
  GTK_WINDOW (dedica_dlg)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dedica_dlg), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (dedica_dlg), TRUE, FALSE, FALSE);

  dialog_dedica = GNOME_DIALOG (dedica_dlg)->vbox;
  gtk_widget_show (dialog_dedica);

  frame_dedica = gtk_frame_new (_(" Dedicato a..."));
  gtk_box_pack_start (GTK_BOX (dialog_dedica), frame_dedica, TRUE, TRUE, 0);
  gtk_widget_show (frame_dedica);

  box_dedica_dati = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame_dedica), box_dedica_dati);
  gtk_widget_show (box_dedica_dati);

  pix_dedica = create_pixmap (dedica_dlg, "./pixmaps/gnome-info.xpm", FALSE);
  gtk_widget_show (pix_dedica);
  gtk_box_pack_start (GTK_BOX (box_dedica_dati), pix_dedica, TRUE, TRUE, 0);

  vseparator = gtk_vseparator_new ();
  gtk_box_pack_start (GTK_BOX (box_dedica_dati), vseparator, TRUE, TRUE, 10);
  gtk_widget_show (vseparator);
  
  dedica = gtk_label_new (_("La mia mamma\nIl mio pap\nla mia fidanzata\nI miei fratelli\ne tutti i miei amici\n"));
  gtk_box_pack_start (GTK_BOX (box_dedica_dati), dedica, TRUE, TRUE, 5);
  gtk_label_set_justify (GTK_LABEL (dedica), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (dedica), TRUE);
  gtk_misc_set_padding (GTK_MISC (dedica), 5, 5);
  gtk_widget_show (dedica);

  box_dialog_bt = GNOME_DIALOG (dedica_dlg)->action_area;
  gtk_button_box_set_layout (GTK_BUTTON_BOX (box_dialog_bt), 
			     GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (box_dialog_bt), 8);
  gnome_dialog_append_button (GNOME_DIALOG (dedica_dlg), 
			      GNOME_STOCK_BUTTON_OK);
  gtk_widget_show (box_dialog_bt);

  dedica_ok_bt = g_list_last (GNOME_DIALOG (dedica_dlg)->buttons)->data;
  GTK_WIDGET_SET_FLAGS (dedica_ok_bt, GTK_CAN_DEFAULT);
  gtk_signal_connect_object(GTK_OBJECT (dedica_ok_bt), "clicked",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      GTK_OBJECT(dedica_dlg)); 
  gtk_widget_show (dedica_ok_bt);

  gtk_widget_show(dedica_dlg);
}


void info(GtkWidget *w, gpointer data)
{
  GtkWidget *dialogo;

  dialogo = gnome_about_new(_("Rubrica"), VERSIONE,
			   _("(C) 2000 Fragale Nicola"),
			   autore,
			   _("Una piccola rubrica per Gnome"),
			   NULL  /* sostituire questo NULL con una path
				    ad una immagine,
				    es: ".../immagine.xpm" */
				   );
  gtk_widget_show(dialogo);
  return;
}

void file_error(gchar *nomefile, gchar *modo)
{
  GtkWidget *messaggio;
  gchar *buffer;
  gint len;

  len = strlen("Errore! non  possibile aprire il file: \n in ") + 
    strlen(nomefile) + strlen(modo)+1;
  buffer = g_malloc(len);

  sprintf(buffer,"Errore! non  possibile aprire il file:\n%s in %s",
	  nomefile, modo);

  messaggio = gnome_message_box_new(			    
	    buffer,  
	    GNOME_MESSAGE_BOX_WARNING,
	    GNOME_STOCK_BUTTON_OK, NULL);

  gnome_dialog_run_and_close (GNOME_DIALOG (messaggio));
  g_free(buffer);
} 

void modifica_error(void)
{
  GtkWidget *dialogo;
  
  gchar *messaggio;

  messaggio = strdup("Attenzione!\nOccore selezionare un elemento\ndalla lista dei nominativi\nprima di poterlo modificare.\n");

  dialogo = gnome_message_box_new (
	  messaggio,
	  GNOME_MESSAGE_BOX_WARNING,
	  GNOME_STOCK_BUTTON_OK, NULL);

  gnome_dialog_run_and_close (GNOME_DIALOG (dialogo));
}
