/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gnome.h>
#include <stdio.h>
#include <stdlib.h>
#include "callback.h"
#include "rubrica.h"
#include "files.h"
#include "util.h"


extern FileRubrica *fr;
extern GnomeRubrica *apprub;
extern GList *lista;
extern gint tot;

GtkWidget *fileselection;

void crea_fileselection (gchar *titolo)
{
  fileselection = gtk_file_selection_new (_(titolo));

  GTK_WINDOW (fileselection)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (fileselection),GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (fileselection), FALSE, FALSE, FALSE);
  
  gtk_signal_connect(GTK_OBJECT(fileselection), "destroy", 
		     (GtkSignalFunc) gtk_widget_destroy, &fileselection);
/*
  NOTA:
  il valore da passare alla funzione di callback, e da usare nella funzione di
  collegamento, deve sempre essere un puntatore (un indirizzo di memoria) 
  ==> &genere <==. Ho avuto tantissimi problemi finch non ho usato l'indirizzo
  della variabile.
  Quando cliccavo su ok, per salvare il file, ottenevo sempre un sementation
  fault. Ho provato a collegare al bottone ok anche la funzione 
  gtk_widget_destroy, da richiamare in sequenza a ok_fs_click.
  Ho distrutto il widget esplicitamente. Ho simulato la pressione del tasto 
  cancel. Tutto inutile finch non ho passato alla funzione di callback 
  l'indirizzo di genere
*/
  gtk_signal_connect_object(GTK_OBJECT
			    (GTK_FILE_SELECTION(fileselection)->ok_button),
			    "clicked",
			    (GtkSignalFunc) ok_fs_click, NULL);

  gtk_signal_connect_object(GTK_OBJECT
			    (GTK_FILE_SELECTION(fileselection)->cancel_button),
			    "clicked",
			    (GtkSignalFunc) gtk_widget_destroy,
			    GTK_OBJECT(fileselection));       

  gtk_widget_show(fileselection);
}

void ok_fs_click(GtkWidget *bott)
{
  gint risultato;

  switch (fr->modo)
    {
    case NUOVO:
      lista = NULL;
      break;
    case APRI:
      lista = NULL; /* inizializzo la nuova lista */
      risultato = file_apri(fr,fileselection);
      break;
    case SALVA:
      risultato = file_salva(fr, fileselection);
      break;
    case SALVA_COME:   
      risultato = file_salva_come(fr,fileselection);    
      break;
    default:
      break;
    }

/*  se l'elaborazione precedente  stata positiva, allora
    simulo la pressione del tasto annulla, per chiudere la 
    finestra di dialogo
*/
  if (risultato)
    gtk_button_clicked(GTK_BUTTON
		       (GTK_FILE_SELECTION(fileselection)->cancel_button));

/* 
static gint
fs_key_event (GtkFileSelection *fsel, GdkEventKey *event)
{
   if (event->keyval == GDK_Escape)
   {
     gtk_button_clicked(GTK_BUTTON(fileselection->cancel_button));
     return 1;
   }
   else
      return 0;
}

funzione copiata dal sorgente file.c di gnumeric-0.38
viene intercettata la pressione del tasto ESC e, per chiudere l'applicazione,
si simula la pressione del tasto annulla
*/

}

void ok_fs_click_new(GtkWidget *w, GtkWidget *fs)
{
}


gint file_apri( FileRubrica *fr, GtkWidget *fs)
{ 
  gchar *buffer;

  if (!fr->nomefile) {
    buffer = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
    fr->path = strdup(buffer);
    fr->nomefile = g_basename(fr->path);
    fr->directory = g_dirname(fr->path);
  }

  if ( ((fr->fp = fopen(fr->nomefile,"r")) == NULL) &&
       ((fr->fp = fopen(fr->path,"r")) == NULL)) {   
    file_error(fr->nomefile, "lettura");
    fr->nomefile = NULL;
    fr->path = NULL;
    return 0; /* ERRORE */
  }
  else {    
    leggi_rubrica(fr);
  }

  if (apprub->mostra_path)
    gtk_label_set_text(GTK_LABEL(apprub->label_path_file), fr->path);
  else 
    gtk_label_set_text(GTK_LABEL(apprub->label_path_file), fr->nomefile);
  
  return 1; /* OK */
}


void leggi_rubrica(FileRubrica *fr)
{ 
  gchar buffer[100];
  gint n=0;
  gint elementi = 0;
  gchar ch;
  gpointer dato;
  gboolean nota = FALSE;

  Token token;

  gchar *item;
  TipoRubrica *tr;
  TelNum *tel;

  GList *lst;
  GList *listweb = NULL;
  GList *listmail = NULL;
  GList *listtel = NULL;
  
  while (!feof(fr->fp)){

    n=0;
    if (!nota) {
      while ( ((( gchar) ch = fgetc(fr->fp)) != '\n') && ch != EOF)
	buffer[n++]=ch;
      buffer[n]='\x0';
    }
    else {
      gint i=0;

      for (i; i < tr->lunghezza; i++)
 	buffer[n++] = fgetc(fr->fp);
      buffer[n] = '\000';
    }
          
    dato = estrai_dato(buffer, &token);
    
    switch(token) {

    case BEGIN:
      lst = NULL;
      break;
      
    case BEGIN_ITEM:
      tr = (TipoRubrica *)g_malloc(sizeof(TipoRubrica));
      listweb = NULL;
      listmail = NULL;
      listtel = NULL;
      break;
      
    case CANCELLABILE:
      if (strcmp(dato, "0") == 0)
	tr->cancellabile = FALSE;
      else 
	tr->cancellabile = TRUE;
      break;

    case EDITABILE:
      if (strcmp(dato, "0") == 0)
	tr->editabile = FALSE;
      else 
	tr->editabile = TRUE;
      break;

    case SCHEDA:
      tr->nome_scheda = (gchar *)dato;
      break;
      
    case NOME:
      tr->nome = (gchar *)dato; 
      break;

    case COGNOME: 
      tr->cognome = (gchar *)dato;
      break;

    case PROFESSIONE:
      tr->professione = (gchar *)dato;
      break;

    case VIA:
      tr->via = (gchar *)dato; 
      break;

    case NUMERO:
      tr->numero = (gchar *)dato;
      break;

    case CITTA:
      tr->citta = (gchar *)dato; 
      break;

    case PROVINCIA:
      tr->provincia = (gchar *)dato;
      break;

    case CAP:
      tr->cap = (gchar *)dato;
      break;

    case STATO:
      tr->stato = (gchar *)dato;
      break;

    case WEB:
      item = (gchar *)dato;
      listweb = g_list_append(listweb, item); 
      break;

    case MAIL:
      item = (gchar *)dato; 
      listmail = g_list_append(listmail, item);
      break;

    case TELEFONO:
      tel = (TelNum *) g_malloc(sizeof(TelNum));

      item = (gchar *)dato;
      tel->numero = item;
      break;

    case TIPO:
      tel->tipo = determina_tipo_telefono(dato);
      listtel = g_list_append(listtel, tel);
      break;

    case LEN_NOTE:
      tr->lunghezza = atoi(dato);
      nota = TRUE;
      break;

    case NOTE:
      tr->note= (gchar *) dato;
      nota = FALSE;
      break;

    case NOTE_NULLE:
      tr->note = NULL;
      nota = FALSE;
      break;

    case END_ITEM:
      tr->web = listweb;
      tr->mail = listmail;
      tr->telefono = listtel;
      lst = g_list_append(lst, tr);
      elementi++;
      fr->spiazzamento = ftell(fr->fp);
      break;

    case END:  
    case SCONOSCIUTO:     
      break;

    default:
      break;
    } // switch
    
  } // while
  
  fclose (fr->fp);

  tot = elementi;
  fr->elementi_salvati = elementi;
  fr->elementi_letti = elementi;
  
  lista = lst;
  mostra_lista(lista);
}


gint file_salva(FileRubrica *fr, GtkWidget *fs)
{
  gchar *buffer;
  
  if (!fr->nomefile){
    buffer = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
    fr->path = strdup(buffer);
    fr->nomefile = g_basename(fr->path);
    fr->directory = g_dirname(fr->path);
  }

  if ((fr->fp = fopen(fr->nomefile,"a+")) == NULL) {
    file_error(fr->nomefile, "scrittura");
    fr->nomefile = NULL;
    fr->path = NULL;
    return 0; /* ERRORE */
  }
  else 
    salva_rubrica(fr, lista);

  if (apprub->mostra_path)
    gtk_label_set_text(GTK_LABEL(apprub->label_path_file), fr->path);
  else 
    gtk_label_set_text(GTK_LABEL(apprub->label_path_file), fr->nomefile);
  
  return 1; /* OK */
}


gint file_salva_come(FileRubrica *fr, GtkWidget *fs)
{  
  gchar *buffer;
  
  buffer = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
  fr->path = strdup(buffer);
  fr->nomefile = g_basename(fr->path);
  fr->directory = g_dirname(fr->path);
  
  if ((fr->fp = fopen(fr->nomefile,"w")) == NULL) {
    file_error(fr->nomefile, "scrittura");
    fr->nomefile = NULL;
    fr->path = NULL;
    return 0; /* ERRORE */
  }
  else 
    salva_rubrica(fr, lista);
  
  if (apprub->mostra_path)
    gtk_label_set_text(GTK_LABEL(apprub->label_path_file), fr->path);
  else 
    gtk_label_set_text(GTK_LABEL(apprub->label_path_file), fr->nomefile);

  return 1; /* OK */
}


void salva_rubrica(FileRubrica *fr, GList *lst)
{    
  TipoRubrica *item;
  GList *alias;
  gint n=0;
  gint elementi_lista;

  elementi_lista = g_list_length(lst);
  alias = lst;   
  
  if(fr->elementi_salvati != 0) {
    while (n != fr->elementi_salvati){
      alias = alias->next;
      n++;
    }
  }
  else { // fr->elementi_salvati = 0
     fprintf(fr->fp, "BEGIN\n");
  }
  
  while (alias != NULL) {
    /*    lista tlc, telecomunicazioni ==> web, mail, telefono
     */
    GList *tlc_lst;
    
    item = (TipoRubrica*) alias->data;
    
    fprintf(fr->fp,"BEGIN_ITEM\n");      
    
    fprintf(fr->fp,"CANCELLABILE=%d\n", item->cancellabile);    
    fprintf(fr->fp,"EDITABILE=%d\n",item->editabile);
    fprintf(fr->fp,"SCHEDA=%s\n",item->nome_scheda);
    fprintf(fr->fp,"NOME=%s\n",item->nome);
    fprintf(fr->fp,"COGNOME=%s\n",item->cognome);
    fprintf(fr->fp,"PROFESSIONE=%s\n",item->professione);
    fprintf(fr->fp,"VIA=%s\n",item->via);
    fprintf(fr->fp,"NUMERO=%s\n",item->numero);
    fprintf(fr->fp,"CITTA'=%s\n",item->citta);
    fprintf(fr->fp,"PROVINCIA=%s\n",item->provincia);
    fprintf(fr->fp,"CAP=%s\n",item->cap);
    fprintf(fr->fp,"STATO=%s\n",item->stato);
    
    tlc_lst = item->web;
    while (tlc_lst != NULL) { 
      fprintf(fr->fp,"WEB=%s\n",(gchar*) tlc_lst->data);
      
      tlc_lst = tlc_lst->next;
    }
    
    tlc_lst = item->mail;
    while (tlc_lst != NULL) {  
      fprintf(fr->fp,"MAIL=%s\n",(gchar*) tlc_lst->data);
      
      tlc_lst = tlc_lst->next;
    }
      
    tlc_lst = item->telefono;
    while (tlc_lst != NULL) {    
      TelNum *tel;
      
      tel = (TelNum*)tlc_lst->data;
      
      fprintf(fr->fp,"TELEFONO=%s\n",tel->numero);
      fprintf(fr->fp,"TIPO=%d\n",tel->tipo);

      tlc_lst = tlc_lst->next;
    }

    if ( (item->lunghezza == 0) && (item->note == NULL))
      
      fprintf(fr->fp,"NOTE_NULLE\n");
    else {
      fprintf(fr->fp,"LEN_NOTE=%d\n", item->lunghezza+5);
      fprintf(fr->fp,"NOTE=%s\n", item->note);
    }

    fprintf(fr->fp,"END_ITEM\n\n");
    
    n++;
    alias = alias->next;
  }
  
  fr->elementi_salvati = n;

  fflush(fr->fp);     
  fclose(fr->fp);   
}



