#include <gnome.h>
#include "menu.h"
#include "callback.h"
#include "dialoghi.h"
#include "interfaccia.h"
#include "init.h"
#include "util.h"
#include "rubrica.h"

extern TipoRubrica *rub;
extern FileRubrica *fr;
extern TelNum *tel_num; 
extern gchar *titolo[3];
extern gchar *item_view[16][3];
extern gboolean editato;
extern GList *lista;
extern GList *registro;


void crea_frame_dati(GnomeRubrica *apprub, GtkWidget *box)
{
  GtkWidget *clist_dati;
  GtkWidget *frame_dati;
  GtkWidget *scroll_dati;             // scrollwindow dati
  gchar *titolo[3] = {"", "", ""};

  /* frame dati */
  frame_dati = gtk_frame_new(" Dati scheda ");
  gtk_box_pack_start(GTK_BOX(box),frame_dati, TRUE, TRUE,0);
  gtk_widget_show(frame_dati);
  
  scroll_dati = gtk_scrolled_window_new(NULL,NULL);
  gtk_container_add(GTK_CONTAINER(frame_dati), scroll_dati);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_dati), 
				 GTK_POLICY_AUTOMATIC,
				 GTK_POLICY_AUTOMATIC);
  gtk_widget_show(scroll_dati);
  
  clist_dati = apprub->clist_dati = gtk_clist_new_with_titles(3, titolo);
  gtk_clist_set_column_width(GTK_CLIST(clist_dati), 0,110);
  gtk_clist_set_column_width(GTK_CLIST(clist_dati), 1,450);
  gtk_clist_set_column_width(GTK_CLIST(clist_dati), 2,50);
  gtk_clist_column_titles_show(GTK_CLIST(clist_dati));
  gtk_clist_set_row_height(GTK_CLIST(clist_dati), 20);

  gtk_container_set_border_width(GTK_CONTAINER(clist_dati),5);
  gtk_container_add(GTK_CONTAINER(scroll_dati), clist_dati);

  registra_widget(clist_dati, "dati scheda");

  gtk_widget_show(clist_dati);
  /* fine frame dati */
}


void crea_frame_spot(GtkWidget *box)
{
  GtkWidget *frame_spot;
  GtkWidget *hbox_spot;
  GtkWidget *vbox_mail;
  GtkWidget *label_rub_ver;
  GtkWidget *mail_url;
  
  gchar *pix_filename;
  GtkWidget *pix;

  GtkWidget *separatore;

  frame_spot = gtk_frame_new(_(" Rubrica "));
  gtk_box_pack_start(GTK_BOX(box), frame_spot, FALSE, FALSE, 0);
  gtk_widget_show(frame_spot);

  hbox_spot = gtk_hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame_spot), hbox_spot);
  gtk_widget_show(hbox_spot);

  pix = gtk_type_new (gnome_pixmap_get_type ());
  pix_filename = gnome_pixmap_file ("./pixmaps/gnome.png");

  if (pix_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pix), pix_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "gnome.png");

  g_free (pix_filename);

  gtk_box_pack_start(GTK_BOX (hbox_spot), pix, TRUE, TRUE, 0);
  gtk_widget_show (pix);

  separatore = gtk_vseparator_new();
  gtk_box_pack_start(GTK_BOX(hbox_spot), separatore, TRUE,TRUE, 3);
  gtk_widget_show(separatore);

  vbox_mail = gtk_vbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox_spot),vbox_mail, TRUE, TRUE, 0);
  gtk_widget_show(vbox_mail);

  label_rub_ver=gtk_label_new("Rubrica v 0.0.2\nCopyrigth 2000 Nicola Fragale");
  gtk_label_set_justify(GTK_LABEL(label_rub_ver), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start(GTK_BOX(vbox_mail),label_rub_ver, FALSE, FALSE, 0);
  gtk_widget_show(label_rub_ver);
  
  /* URL */
  mail_url =gnome_href_new("nicolafragale@libero.it",
			   "mailto: Nicola Fragale (nicolafragale@libero.it)");
  gtk_box_pack_start(GTK_BOX(vbox_mail),mail_url,FALSE,FALSE,0);

  registra_widget(mail_url, "url");

  gtk_widget_show(mail_url);
}  /* fine frame spot */


int disegna_app(GnomeRubrica *apprub)
{ 
  gint i;
  GtkWidget *separatore;
  GtkWidget *app;               // alias per apprub->window
  GtkWidget *clista;            // alias per apprub->clista
  
  GtkWidget *label_path_file;   // alias
  GtkWidget *label_file;
  
  GtkAdjustment *adj;           // alias 
  GtkWidget *progressbar;       // alias
  GtkWidget *appbox;            // box principale applicazione    

  GtkWidget *vbox_lista;
  GtkWidget *frame_lista;
  GtkWidget *scroll_lista;      // scrollwindow lista
  GtkWidget *viewport_lista;     
  GtkWidget *hbox_statistiche;
  GtkWidget *vbox_statistico;
  GtkWidget *hbox_nome_file;
  GtkWidget *hbox_progressbar;
  GtkWidget *label_indirizzi;
  GtkWidget *hbox_bot;
  GtkWidget *vbox_bot;
  GtkWidget *bot_pre;
  GtkWidget *bot_succ;
  
  app = apprub->window;
  /* creo la finestra principale dell'applicazione, 
     definisco le dimensioni,
     definisco le funzioni di callback, 
     creo i menu e inserisco il box principale  */
  gtk_widget_realize(app);
  gtk_window_set_default_size(GTK_WINDOW(app),810,450);
  gtk_container_set_border_width(GTK_CONTAINER(app),3);

  installa_menu_e_toolbar(app);

  /*------------------------------------------------------------*/
  gtk_signal_connect(GTK_OBJECT(app), "delete_event",
		     GTK_SIGNAL_FUNC(chiudi_applicazione), NULL);  

  /* creo il box contenitore di tutta l'applicazione... */
  appbox = gtk_hbox_new(FALSE,0);  // non omogeneo, spaziatura 0

  /*...l'inserisco nel widget app... */
  gnome_app_set_contents(GNOME_APP(app), appbox);

  /*...e lo mostro */
  gtk_widget_show(appbox);

  /* creo il box lista nel box appbox */
  /* box lista */
  vbox_lista = gtk_vbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(appbox),vbox_lista,TRUE,TRUE,0);
  gtk_widget_show(vbox_lista);

  /* frame lista */
  frame_lista = gtk_frame_new(_(" Nominativi "));
  gtk_container_set_border_width(GTK_CONTAINER(frame_lista),4);
  gtk_box_pack_start(GTK_BOX(vbox_lista), frame_lista, TRUE, TRUE, 0);
  
  scroll_lista = gtk_scrolled_window_new(NULL,NULL);
  gtk_container_add(GTK_CONTAINER(frame_lista), scroll_lista);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_lista), 
				 GTK_POLICY_AUTOMATIC,
				 GTK_POLICY_AUTOMATIC);
  gtk_container_set_border_width(GTK_CONTAINER(scroll_lista),5);
  
  viewport_lista = gtk_viewport_new(NULL,NULL);
  gtk_container_add(GTK_CONTAINER(scroll_lista),viewport_lista);


  /*    ************************************
	lista dei Nominativi
  */
  clista = apprub->clista =  gtk_clist_new_with_titles(14,titolo);
  gtk_clist_set_column_width(GTK_CLIST(clista), 0,170);
  gtk_clist_set_column_width(GTK_CLIST(clista), 1,140);
  gtk_clist_set_column_width(GTK_CLIST(clista), 2,140);
  gtk_clist_set_row_height(GTK_CLIST(clista), 15);

  registra_widget(clista, "nominativi");
  
  /* nascondo le colonne con i dati da professione a telefono */
  for (i=3; i<14; i++)
    gtk_clist_set_column_visibility(GTK_CLIST(clista), i, FALSE);

  /*  se clicco su una riga, richiamo la funzione appropriata
   */
  gtk_signal_connect(GTK_OBJECT(clista), "select_row",
		     GTK_SIGNAL_FUNC(selezione_riga_lista), NULL);
  /*    inserisco la clist nella finestra di visualizzazione
  */
  gtk_container_add(GTK_CONTAINER(viewport_lista),clista);

  /*    mostro il "blocco" clista
  */
  gtk_widget_show(clista);
  gtk_widget_show(viewport_lista);
  gtk_widget_show(scroll_lista);
  gtk_widget_show(frame_lista);
  /* frame lista fine */


  /*      *************************************
	  --- box statistiche --- 
  */
  hbox_statistiche = gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox_lista), hbox_statistiche, TRUE, TRUE, 0);
  
  vbox_statistico = gtk_vbox_new(TRUE, 10);
  gtk_container_set_border_width(GTK_CONTAINER(hbox_statistiche), 20);
  gtk_box_pack_start(GTK_BOX(hbox_statistiche),vbox_statistico,TRUE, TRUE,0);
  
  /* box nome del file */
  hbox_nome_file = gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox_statistico),hbox_nome_file, TRUE, TRUE, 0);
  
  label_file = gtk_label_new("file: ");
  gtk_box_pack_start(GTK_BOX(hbox_nome_file), label_file,FALSE, TRUE, 0);
  gtk_label_set_justify(GTK_LABEL(label_file),GTK_JUSTIFY_LEFT);
  gtk_widget_show(label_file);

  label_path_file = apprub->label_path_file = gtk_label_new("");

  gtk_box_pack_start(GTK_BOX(hbox_nome_file), label_path_file, FALSE, TRUE, 0);
  gtk_label_set_justify(GTK_LABEL(label_path_file),GTK_JUSTIFY_LEFT);

  /* DA FARE:
     pad x = 5 */
  gtk_widget_show(label_path_file);
  gtk_widget_show(hbox_nome_file);


  /*      **************************************
	  box della progress bar 
   */
  hbox_progressbar = gtk_hbox_new(FALSE,5);
  gtk_box_pack_start(GTK_BOX(vbox_statistico), hbox_progressbar,FALSE,FALSE,0);

  label_indirizzi = gtk_label_new("Indirizzi inseriti: ");
  gtk_box_pack_start(GTK_BOX(hbox_progressbar),label_indirizzi, FALSE, TRUE,0);
  gtk_label_set_justify(GTK_LABEL(label_indirizzi),GTK_JUSTIFY_LEFT);
  gtk_widget_show(label_indirizzi);
  
  adj = apprub->adj = (GtkAdjustment *) gtk_adjustment_new(0,0,200,1,0,0);
  /* valore iniziale = 0
     valore minimo = 0
     valore massimo = 200
     incremento passo = 1
     incremento pagina = 0
     grandezza pagina = 0 ??
  */

  progressbar = apprub->progressbar = 
    gtk_progress_bar_new_with_adjustment(adj);
  gtk_box_pack_start(GTK_BOX(hbox_progressbar), progressbar,FALSE, FALSE, 3);
  gtk_progress_set_format_string(GTK_PROGRESS(progressbar), "%v");
  gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(progressbar),
				 GTK_PROGRESS_CONTINUOUS);
  gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(progressbar),
				   GTK_PROGRESS_LEFT_TO_RIGHT);
  gtk_progress_set_adjustment(GTK_PROGRESS(progressbar), GTK_ADJUSTMENT(adj));

  registra_widget(progressbar, "progressbar");
  
  gtk_widget_show(progressbar);
  gtk_widget_show(hbox_progressbar);
  gtk_widget_show(vbox_statistico);
  /* box statistico fine */

  separatore = gtk_vseparator_new();
  gtk_box_pack_start(GTK_BOX(hbox_statistiche), separatore, TRUE, TRUE,0);
  gtk_widget_show(separatore);


  /*     ************************************
	 box bottoni:
	 mostra l'elemento pre(cedente) nella lista dei nominativi	
	 mostra l'elemento succ(essivo)	nella lista dei nominativi 
  */
  hbox_bot = gtk_hbox_new(FALSE,2);
  gtk_box_pack_start(GTK_BOX(hbox_statistiche), hbox_bot, TRUE, TRUE, 0);
  gtk_box_set_spacing(GTK_BOX(hbox_bot),5);
  gtk_widget_show(hbox_bot);

  vbox_bot = gtk_vbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(hbox_bot), vbox_bot, TRUE, TRUE, 0);
  gtk_widget_show(vbox_bot);

  bot_pre = gtk_button_new_with_label("prec");
  gtk_box_pack_start(GTK_BOX(vbox_bot), bot_pre, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bot_pre),"clicked",
		     GTK_SIGNAL_FUNC(on_button_prec_clicked),NULL);
  gtk_widget_show(bot_pre);

  vbox_bot = gtk_vbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(hbox_bot), vbox_bot, TRUE, TRUE, 0);
  gtk_widget_show(vbox_bot);

  bot_succ = gtk_button_new_with_label("Succ");
  gtk_box_pack_start(GTK_BOX(vbox_bot), bot_succ, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bot_succ),"clicked",
		     GTK_SIGNAL_FUNC(on_button_succ_clicked),NULL);
  gtk_widget_show(bot_succ);
  /* fine box bot */
  
  gtk_widget_show(hbox_bot);
  gtk_widget_show(hbox_statistiche);
  /* box statistiche fine */ 
  
  separatore = gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox_lista), separatore, TRUE, TRUE,0);
  gtk_widget_show(separatore);
  
  /*    --- frame spot --- 
   */

  crea_frame_spot(vbox_lista); 
  crea_frame_dati(apprub, appbox);
  crea_form_acquisisci(apprub);

  gtk_widget_show(app);

  return 0;
}


void crea_dati_personali_notebook(GnomeRubrica *apprub, GtkWidget *notebook)
{
  GtkWidget *pixmap18;
  gchar *pixmap18_filename;

  GtkWidget *bn_frame_nome;
  GtkWidget *bn_fbox_nome;
  GtkWidget *bn_box_nome;
  GtkWidget *bn_none_lbl;
  GtkWidget *bn_box_cognome;
  GtkWidget *bn_cognome_lbl;
  GtkWidget *bn_box_prof;
  GtkWidget *bn_prof_lbl;
  GtkWidget *bn_frame_indirizzo;
  GtkWidget *bn_box_indirizzo;
  GtkWidget *bn_box_vn;
  GtkWidget *bn_via_lbl;
  GtkWidget *bn_num_lbl;

  GtkWidget *bn_sch;                  // entry scheda
  GtkWidget *bn_nome;                 // entry nome
  GtkWidget *bn_cognome;              // entry cognome 
  GtkWidget *bn_prof;                 // entry professione
  GtkWidget *bn_via;                  // entry via
  GtkWidget *bn_num;                  // entry numero
  GtkWidget *bn_citta;                // entry citta
  GtkWidget *bn_prov;                 // entry provincia
  GtkWidget *bn_cap;                  // entry cap 
  GtkWidget *bn_stato;                // entry stato 

  GtkWidget *bn_box_dati;
  GtkWidget *bn_box_scheda;
  GtkWidget *bn_box_cp;
  GtkWidget *bn_citta_lbl;
  GtkWidget *bn_prov_lbl;
  
  GtkWidget *bn_box_cs;
  GtkWidget *bn_cap_lbl;
  GtkWidget *bn_stato_lbl;
  
  GtkWidget *bn_sc_lbl;               // blocknotes scheda label  
  GtkWidget *bn_dati;

  GtkWidget *hbox_check;
  GtkWidget *check_del;
  GtkWidget *check_edit;

  /*    box atto a raccogliere i dati
   */
  bn_box_dati = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook), bn_box_dati);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_dati), 5);
  registra_widget(bn_box_dati, "dati");
  gtk_widget_show (bn_box_dati);
 
  /*    box per il nome della scheda
   */
  bn_box_scheda = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_dati), bn_box_scheda, TRUE, TRUE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_scheda), 0);
  gtk_widget_show (bn_box_scheda);

  /*    etichetta e entry per il nome della scheda
   */
  bn_sc_lbl = gtk_label_new (_("Nome della scheda: "));
  gtk_box_pack_start (GTK_BOX (bn_box_scheda), bn_sc_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_sc_lbl);
  
  /*    definisco l'entry per acquisire il nome da dare alla scheda
   */
  bn_sch = apprub->scheda = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_scheda), bn_sch, TRUE, TRUE, 0);

  /*    pulisco l'entry e sposto il focus 
   */
  gtk_entry_set_text(GTK_ENTRY(bn_sch),"");
  gtk_widget_grab_focus(bn_sch);
  gtk_widget_show (bn_sch);

  /*   pixmap per la scheda
   */
  pixmap18 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap18_filename = gnome_pixmap_file ("./pixmaps/gnome-scheda.png");
  if (pixmap18_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap18), pixmap18_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "gnome-scheda.png");
  g_free (pixmap18_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_scheda), pixmap18, TRUE, TRUE, 0);
  gtk_widget_show (pixmap18);
  
  /*    box per i check button
  */
  hbox_check = gtk_hbox_new(TRUE, 10);
  gtk_box_pack_start(GTK_BOX(bn_box_dati), hbox_check, FALSE, TRUE, 0);
  gtk_widget_show(hbox_check);

  check_del = gtk_check_button_new_with_label(_("Scheda cancellabile"));
  check_edit = gtk_check_button_new_with_label(_("Scheda modificabile"));

  gtk_box_pack_start(GTK_BOX(hbox_check), check_del, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(hbox_check), check_edit, TRUE, TRUE, 0);
  
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_del), TRUE);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_edit), TRUE);

  registra_widget(check_del, "check del");
  registra_widget(check_edit, "check edit");

  gtk_widget_show(check_del);
  gtk_widget_show(check_edit);
					      

  /*    frame per l'aquisizione dei dati sulla persona
   */
  bn_frame_nome = gtk_frame_new (_(" Nome "));
  gtk_box_pack_start (GTK_BOX (bn_box_dati), bn_frame_nome, TRUE, TRUE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (bn_frame_nome), 3);
  gtk_widget_show (bn_frame_nome);
  
  /*    box per l'acquisizione dei dati personali
   */
  bn_fbox_nome = gtk_vbox_new (TRUE, 10);
  gtk_container_add (GTK_CONTAINER (bn_frame_nome), bn_fbox_nome);
  gtk_widget_show (bn_fbox_nome);
 
  bn_box_nome = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_fbox_nome), bn_box_nome, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_nome), 5);
  gtk_widget_show (bn_box_nome);
  
  /*    label Nome:
   */
  bn_none_lbl = gtk_label_new (_("Nome: "));
  gtk_box_pack_start (GTK_BOX (bn_box_nome), bn_none_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_none_lbl);
 
  /*    entry per l'acquisizione del nome - Nome:
   */
  bn_nome = apprub->nome = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_nome), bn_nome, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_nome),"");
  gtk_widget_show (bn_nome);

  /*    Cognome:
  */
  bn_box_cognome = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_fbox_nome), bn_box_cognome, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_cognome), 5);
  gtk_widget_show (bn_box_cognome);
  
  bn_cognome_lbl = gtk_label_new (_("Cognome: "));
  gtk_box_pack_start (GTK_BOX (bn_box_cognome), bn_cognome_lbl, 
		      FALSE, FALSE, 0);
  gtk_widget_show (bn_cognome_lbl);

  /*    entry Cognome
   */
  bn_cognome = apprub->cognome = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_cognome), bn_cognome, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_cognome),"");
  gtk_widget_show (bn_cognome);
 
  /*    Professione:
   */
  bn_box_prof = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_fbox_nome), bn_box_prof, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_prof), 5);
  gtk_widget_show (bn_box_prof);
  
  bn_prof_lbl = gtk_label_new (_("Professione: "));
  gtk_box_pack_start (GTK_BOX (bn_box_prof), bn_prof_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_prof_lbl);
  
  /*    entry Professione
  */
  bn_prof = apprub->prof = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_prof), bn_prof, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_prof),"");
  gtk_widget_show (bn_prof);
  
  /*    Indirizzo:
  */
  bn_frame_indirizzo = gtk_frame_new (_(" Indirizzo "));
  gtk_box_pack_start (GTK_BOX (bn_box_dati), bn_frame_indirizzo, 
		      TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_frame_indirizzo), 3);
  gtk_widget_show (bn_frame_indirizzo);

  bn_box_indirizzo = gtk_vbox_new (TRUE, 10);
  gtk_container_add (GTK_CONTAINER (bn_frame_indirizzo), bn_box_indirizzo);
  gtk_widget_show (bn_box_indirizzo);
 
  bn_box_vn = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_indirizzo), bn_box_vn, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_vn), 5);
  gtk_widget_show (bn_box_vn);
   
  bn_via_lbl = gtk_label_new (_("Via: "));
  gtk_box_pack_start (GTK_BOX (bn_box_vn), bn_via_lbl, TRUE, TRUE, 0);
  gtk_widget_show (bn_via_lbl);
 
  /*    entry via
  */
  bn_via = apprub->via = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_vn), bn_via, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_via),"");
  gtk_widget_show (bn_via);

  /*    Numero:
  */
  bn_num_lbl = gtk_label_new (_("Numero: "));
  gtk_box_pack_start (GTK_BOX (bn_box_vn), bn_num_lbl, TRUE, TRUE, 5);
  gtk_widget_show (bn_num_lbl);

  /*    entry numero
  */
  bn_num = apprub->num = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_vn), bn_num, FALSE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_num),"");
  gtk_widget_show (bn_num);

  /*    CITTA'
   */
  bn_box_cp = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_indirizzo), bn_box_cp, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_cp), 5);
  gtk_widget_show (bn_box_cp);
  
  bn_citta_lbl = gtk_label_new (_("Citt: "));
  gtk_box_pack_start (GTK_BOX (bn_box_cp), bn_citta_lbl, TRUE, TRUE, 0);
  gtk_widget_show (bn_citta_lbl);

  /*    entry Citt:
  */
  bn_citta = apprub->citta = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_cp), bn_citta, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_citta),"");
  gtk_widget_show (bn_citta);
 
  /*    Provincia
  */
  bn_prov_lbl = gtk_label_new (_("Provincia: "));
  gtk_box_pack_start (GTK_BOX (bn_box_cp), bn_prov_lbl, TRUE, TRUE, 5);
  gtk_widget_show (bn_prov_lbl);
  
  /*    entry Provincia:
  */
  bn_prov = apprub->prov = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_cp), bn_prov, FALSE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_prov),"");
  gtk_widget_show (bn_prov);
  
  /*    ???
   */
  bn_box_cs = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_indirizzo), bn_box_cs, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_cs), 5);
  gtk_widget_show (bn_box_cs);
  
  /*    CAP
  */
  bn_cap_lbl = gtk_label_new (_("Cap:  "));
  gtk_box_pack_start (GTK_BOX (bn_box_cs), bn_cap_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_cap_lbl);
 
  bn_cap = apprub->cap = gtk_entry_new_with_max_length (10);
  gtk_box_pack_start (GTK_BOX (bn_box_cs), bn_cap, FALSE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_cap),"");
  gtk_widget_show (bn_cap);
  
  /*    stato
  */
  bn_stato_lbl = gtk_label_new (_("Stato: "));
  gtk_box_pack_start (GTK_BOX (bn_box_cs), bn_stato_lbl, FALSE, FALSE, 5);
  gtk_widget_show (bn_stato_lbl);
 
  /*    entry Stato:
  */
  bn_stato = apprub->stato = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_cs), bn_stato, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_stato),"");
  gtk_widget_show (bn_stato);
 
  /*    Notebook Dati Personali
  */
  bn_dati = gtk_label_new (_("Dati personali"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), 
			      gtk_notebook_get_nth_page 
			      (GTK_NOTEBOOK (notebook), 0), bn_dati);
  gtk_widget_show (bn_dati);
 
}


void crea_rete_notebook(GnomeRubrica *apprub, GtkWidget *notebook)
{
  GtkWidget *box_rete;
  GtkWidget *bn_fbox_web;
  GtkWidget *bn_box_web1;
  GtkWidget *bn_box_web2;
  GtkWidget *bn_web_lbl;

  GtkWidget *bn_pix_web;
  GtkWidget *bn_box_web_list;
  GtkWidget *bn_bot_web;
  GtkWidget *bn_bot_web_add;
  GtkWidget *bn_bot_web_edit;
  GtkWidget *bn_bot_web_canc;
  GtkWidget *bn_frame_web;
  GtkWidget *bn_scroll_web;
  GtkWidget *bn_view_web;
  
  GtkWidget *bn_fbox_mail;
  GtkWidget *bn_box_email1;
  GtkWidget *bn_box_email2;
  GtkWidget *bn_mail_lbl;

  GtkWidget *bn_pix_mail;
  GtkWidget *bn_box_mail_list;
  GtkWidget *bn_bot_mail;
  GtkWidget *bn_bot_mail_add;
  GtkWidget *bn_bot_mail_edit;
  GtkWidget *bn_bot_mail_canc;
  GtkWidget *bn_frame_mail;
  GtkWidget *bn_scroll_mail;
  GtkWidget *bn_view_mail;
  GtkWidget *bn_web;                  // entry web
  GtkWidget *bn_mail;                 // entry mail
  GtkWidget *bn_rete;                 // entry rete  
  GtkWidget *bn_mail_list;            // lista mail
  GtkWidget *bn_web_list;             // lista web
  gchar *bn_pix_mail_filename;
  gchar *bn_pix_web_filename;

  /*    Notebook Rete
  */
  box_rete = gtk_vbox_new (FALSE, 10);
  gtk_container_add (GTK_CONTAINER (notebook), box_rete);
  gtk_widget_set_name(box_rete, "box rete");
  registra_widget(box_rete, "rete");
  gtk_container_set_border_width (GTK_CONTAINER (box_rete), 5);
  gtk_widget_show (box_rete);
  
  bn_fbox_web = gtk_frame_new (_(" Indirizzi Web "));
  gtk_box_pack_start (GTK_BOX (box_rete), bn_fbox_web, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_fbox_web), 5);
  gtk_widget_show (bn_fbox_web);
  
  bn_box_web1 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (bn_fbox_web), bn_box_web1);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_web1), 3);
  gtk_widget_show (bn_box_web1);
  
  bn_box_web2 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_web1), bn_box_web2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_web2), 5);
  gtk_widget_show (bn_box_web2);
  
  bn_web_lbl = gtk_label_new (_("Pagina Web: "));
  gtk_box_pack_start (GTK_BOX (bn_box_web2), bn_web_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_web_lbl);
 
  /*    entry web
  */
  bn_web = apprub->web = gtk_entry_new();
  gtk_widget_set_name(bn_web, "entry web");
  registra_widget(bn_web, "entry web");
  gtk_box_pack_start (GTK_BOX (bn_box_web2), bn_web, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_web),"");
  gtk_widget_show (bn_web);

  /*      pixmap web
   */
  bn_pix_web = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_web_filename = gnome_pixmap_file ("./pixmaps/WorldChat.xpm");
  if (bn_pix_web_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_web), bn_pix_web_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "WorldChat.xpm");
  g_free (bn_pix_web_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_web2), bn_pix_web, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_web);
 


  /*    ******************************
	Lista Web
  */
  bn_box_web_list = gtk_hbox_new (FALSE, 10);
  gtk_box_pack_start (GTK_BOX (bn_box_web1), bn_box_web_list, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_web_list), 5);
  gtk_widget_show (bn_box_web_list);
 
  /*    Bottoni WEB: 
	- aggiungi
	- modifica
	- cancella
  */
  bn_bot_web = gtk_vbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_web_list), bn_bot_web, FALSE, TRUE, 0);
  gtk_widget_show (bn_bot_web);
 
  /*    aggiungi
  */
  bn_bot_web_add = gtk_button_new_with_label (_("Aggiungi"));
  gtk_container_add (GTK_CONTAINER (bn_bot_web), bn_bot_web_add);
  registra_widget(bn_bot_web_add, "web add");
  GTK_WIDGET_SET_FLAGS (bn_bot_web_add, GTK_CAN_DEFAULT);
  gtk_widget_show (bn_bot_web_add);
 
  /*    modifica
  */
  bn_bot_web_edit = gtk_button_new_with_label (_("Modifica"));
  gtk_container_add (GTK_CONTAINER (bn_bot_web), bn_bot_web_edit);
  gtk_widget_set_sensitive(bn_bot_web_edit, FALSE);
  registra_widget(bn_bot_web_edit, "web edit");
  GTK_WIDGET_SET_FLAGS (bn_bot_web_edit, GTK_CAN_DEFAULT);
  gtk_widget_show (bn_bot_web_edit);
  
  /*    cancella
  */
  bn_bot_web_canc = gtk_button_new_with_label (_("Elimina"));
  gtk_container_add (GTK_CONTAINER (bn_bot_web), bn_bot_web_canc);
  GTK_WIDGET_SET_FLAGS (bn_bot_web_canc, GTK_CAN_DEFAULT);
  gtk_widget_set_sensitive(bn_bot_web_canc, FALSE);
  registra_widget(bn_bot_web_canc, "web canc");
  gtk_widget_show (bn_bot_web_canc);
  
  /*    frame web
  */
  bn_frame_web = gtk_frame_new (_(" web "));
  gtk_box_pack_start (GTK_BOX (bn_box_web_list), bn_frame_web, TRUE, TRUE, 0);
  gtk_widget_show (bn_frame_web);
  
  /*    scrolled window contenente la lista delle pagine web inserite
  */
  bn_scroll_web = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (bn_frame_web), bn_scroll_web);
  gtk_widget_show (bn_scroll_web);
  
  /*    viewport per poter vedere la lista web
  */
  bn_view_web = gtk_viewport_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (bn_scroll_web), bn_view_web);
  gtk_widget_show (bn_view_web);

  /*    la lista web    -- clist di una colonna --
  */
  bn_web_list = apprub->web_list = gtk_clist_new(1);
  gtk_container_add (GTK_CONTAINER (bn_view_web), bn_web_list);

  gtk_clist_set_selection_mode(GTK_CLIST(bn_web_list),
			       GTK_SELECTION_SINGLE );
  gtk_signal_connect(GTK_OBJECT(bn_web_list), "select_row",
		     GTK_SIGNAL_FUNC(selezionata_riga), 
		     "web");

  gtk_widget_show (bn_web_list);
 


  /*    ******************************
	Lista Mail
  */
  bn_fbox_mail = gtk_frame_new (_(" Indirizzi email "));
  gtk_box_pack_start (GTK_BOX (box_rete), bn_fbox_mail, TRUE, TRUE, 2);
  gtk_container_set_border_width (GTK_CONTAINER (bn_fbox_mail), 5);
  gtk_widget_show (bn_fbox_mail);

  bn_box_email1 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (bn_fbox_mail), bn_box_email1);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_email1), 3);
  gtk_widget_show (bn_box_email1);
 
  bn_box_email2 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_email1), bn_box_email2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_email2), 5);
  gtk_widget_show (bn_box_email2);
 
  /*    label mail
  */
  bn_mail_lbl = gtk_label_new (_("Indirizzo email: "));
  gtk_box_pack_start (GTK_BOX (bn_box_email2), bn_mail_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_mail_lbl);

  /*    entry mail
  */
  bn_mail = apprub->mail = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_email2), bn_mail, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_mail),"");
  gtk_widget_show (bn_mail);
 
  bn_pix_mail = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_mail_filename = gnome_pixmap_file ("./pixmaps/MailOpen.xpm");
  if (bn_pix_mail_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_mail), bn_pix_mail_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "MailOpen.xpm");
  g_free (bn_pix_mail_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_email2), bn_pix_mail, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_mail);

  bn_box_mail_list = gtk_hbox_new (FALSE, 10);
  gtk_box_pack_start (GTK_BOX (bn_box_email1), bn_box_mail_list,
		      TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_mail_list), 5);
  gtk_widget_show (bn_box_mail_list);

  /*    Bottoni MAIL: 
	- aggiungi
	- modifica
	- cancella
   */
  bn_bot_mail = gtk_vbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_mail_list), bn_bot_mail, 
		      FALSE, FALSE, 0);
  gtk_widget_show (bn_bot_mail);
 
  /*    aggiungi
  */
  bn_bot_mail_add = gtk_button_new_with_label (_("Aggiungi"));
  gtk_container_add (GTK_CONTAINER (bn_bot_mail), bn_bot_mail_add);
  registra_widget(bn_bot_mail_add, "mail add");
  GTK_WIDGET_SET_FLAGS (bn_bot_mail_add, GTK_CAN_DEFAULT);
  gtk_widget_show (bn_bot_mail_add);
  
  /*    modifica
  */
  bn_bot_mail_edit = gtk_button_new_with_label (_("Modifica"));
  gtk_container_add (GTK_CONTAINER (bn_bot_mail), bn_bot_mail_edit);
  GTK_WIDGET_SET_FLAGS (bn_bot_mail_edit, GTK_CAN_DEFAULT);
  gtk_widget_set_sensitive(bn_bot_mail_edit, FALSE);
  registra_widget(bn_bot_mail_edit, "mail edit");
  gtk_widget_show (bn_bot_mail_edit);

  /*    cancella
  */
  bn_bot_mail_canc = gtk_button_new_with_label (_("Elimina"));
  gtk_container_add (GTK_CONTAINER (bn_bot_mail), bn_bot_mail_canc);
  GTK_WIDGET_SET_FLAGS (bn_bot_mail_canc, GTK_CAN_DEFAULT);
  gtk_widget_set_sensitive(bn_bot_mail_canc, FALSE);
  registra_widget(bn_bot_mail_canc, "mail canc");
  gtk_widget_show (bn_bot_mail_canc);

  /*    frame mail
   */
  bn_frame_mail = gtk_frame_new (_(" email "));
  gtk_box_pack_start (GTK_BOX (bn_box_mail_list), bn_frame_mail, 
		      TRUE, TRUE, 0);
  gtk_widget_show (bn_frame_mail);

  /*    scrolled window mail
  */
  bn_scroll_mail = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (bn_frame_mail), bn_scroll_mail);
  gtk_widget_show (bn_scroll_mail);
 
  /*    viewport mail
  */
  bn_view_mail = gtk_viewport_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (bn_scroll_mail), bn_view_mail);
  gtk_widget_show (bn_view_mail);
 
  /*    lista mail
  */
  bn_mail_list = apprub->mail_list = gtk_clist_new(1);
  gtk_container_add (GTK_CONTAINER (bn_view_mail), bn_mail_list);

  gtk_clist_set_selection_mode(GTK_CLIST(bn_mail_list),
			       GTK_SELECTION_SINGLE );
  gtk_signal_connect(GTK_OBJECT(bn_mail_list), "select_row",
		     GTK_SIGNAL_FUNC(selezionata_riga), 
		     "mail");

  gtk_widget_show (bn_mail_list);
  

  /*   ****************************************
       Notebook Rete
  */
  bn_rete = gtk_label_new (_("Rete"));
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook),
			      gtk_notebook_get_nth_page 
			      (GTK_NOTEBOOK (notebook), 1), bn_rete);
  gtk_widget_show (bn_rete);
 

  /*    Collegamento dei bottoni alle funzioni di callback
  */
  
  /*    web aggiungi 
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_web_add), "clicked",
                      GTK_SIGNAL_FUNC (web_add_clicked),
                      NULL);
  /*    web modifica
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_web_edit), "clicked",
                      GTK_SIGNAL_FUNC (web_edit_clicked),
                      GTK_CLIST(bn_web_list));
  /*    web cancella
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_web_canc), "clicked",
                      GTK_SIGNAL_FUNC (web_canc_clicked),NULL);
  /*    main aggiungi
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_mail_add), "clicked",
                      GTK_SIGNAL_FUNC (mail_add_clicked),
                      NULL);
  /*    mail modifica
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_mail_edit), "clicked",
                      GTK_SIGNAL_FUNC (mail_edit_clicked),
                      NULL);
  /*    mail cancella
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_mail_canc), "clicked",
                      GTK_SIGNAL_FUNC (mail_canc_clicked),
                      NULL);
}


void crea_telefono_notebook(GnomeRubrica *apprub, GtkWidget * notebook)
{
  GtkWidget *bn_box_telefono;
  GtkWidget *bn_box_tel;
  GtkWidget *bn_tel_lbl;
  GtkWidget *hbuttonbox1;
  GtkWidget *bn_pix_tel;
  GtkWidget *bn_box_radio_lst;
  GtkWidget *bn_fbox_tel;
  GtkWidget *bn_box_dati_tel;
  GtkWidget *bn_box_tel_pix;
  GtkWidget *bn_box_tel_pix1;
  GtkWidget *bn_box_pix_tel;

  GtkWidget *bn_pix_casa;
  GtkWidget *bn_pix_work;
  GtkWidget *bn_pix_fax;
  GtkWidget *bn_pix_cell;
  GtkWidget *bn_box_radio;

  GSList *bn_box_radio_group = NULL;
 
  GtkWidget *bn_scroll_tel_clst;
  GtkWidget *bn_clist_tel_lbl;
  GtkWidget *bn_clist_quale_lbl;

  GtkWidget *bn_tel;                  // entry telefono 
  GtkWidget *bn_radio_casa;
  GtkWidget *bn_radio_work;
  GtkWidget *bn_radio_fax;
  GtkWidget *bn_radio_cell;
  GtkWidget *bn_bot_tel_add;
  GtkWidget *bn_bot_tel_edit;
  GtkWidget *bn_bot_tel_canc;
  GtkWidget *bn_tel_clista;                // clista telefoni
  gchar *bn_pix_tel_filename;
  gchar *bn_pix_casa_filename;
  gchar *bn_pix_work_filename; 
  gchar *bn_pix_fax_filename;
  gchar *bn_pix_cell_filename;

  /*    ***************************************
	Notebook Telefono
  */
  bn_box_telefono = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook), bn_box_telefono);
  gtk_widget_show (bn_box_telefono);
  
  bn_box_tel = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_telefono), bn_box_tel, TRUE, TRUE, 0);
  gtk_widget_show (bn_box_tel);
 
  bn_tel_lbl = gtk_label_new (_("Numero di telefono: "));
  gtk_box_pack_start (GTK_BOX (bn_box_tel), bn_tel_lbl, FALSE, FALSE, 0);
  gtk_widget_show (bn_tel_lbl);
  
  /*    entry telefono
  */
  bn_tel = apprub->tel =  gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_tel), bn_tel, TRUE, TRUE, 0);
  gtk_entry_set_text(GTK_ENTRY(bn_tel),"");
  gtk_widget_show (bn_tel);
 
  /*    Icona Telefono
  */
  bn_pix_tel = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_tel_filename = gnome_pixmap_file ("./pixmaps/gnome-talk.png");
  if (bn_pix_tel_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_tel), bn_pix_tel_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "gnome-talk.png");
  g_free (bn_pix_tel_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_tel), bn_pix_tel, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_tel);
  
  /*  box per i radio button
   */
  bn_box_radio_lst = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_telefono), bn_box_radio_lst, 
		      TRUE, TRUE, 0);
  gtk_widget_show (bn_box_radio_lst);
 
  bn_fbox_tel = gtk_frame_new (_(" Telefono di... "));
  gtk_box_pack_start (GTK_BOX (bn_box_radio_lst), bn_fbox_tel, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_fbox_tel), 5);
  gtk_widget_show (bn_fbox_tel);
 
  bn_box_dati_tel = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (bn_fbox_tel), bn_box_dati_tel);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_dati_tel), 3);
  gtk_widget_show (bn_box_dati_tel);
  
  /*    box per le pixmap di
	- telefono casa
	- telefono ufficio
	- fax
	- telefono cellulare
  */
  bn_box_tel_pix = gtk_vbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_dati_tel), bn_box_tel_pix, 
		      FALSE, FALSE, 0);
  gtk_widget_show (bn_box_tel_pix);
  
  bn_box_tel_pix1 = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_tel_pix), bn_box_tel_pix1,
		      TRUE, TRUE, 0);
  gtk_widget_show (bn_box_tel_pix1);
  
  bn_box_pix_tel = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bn_box_tel_pix1), bn_box_pix_tel,
		      TRUE, TRUE, 0);
  gtk_widget_show (bn_box_pix_tel);

  /*    casa
  */
  bn_pix_casa = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_casa_filename = gnome_pixmap_file ("./pixmaps/gnome-home.png");
  if (bn_pix_casa_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_casa), bn_pix_casa_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "gnome-home.png");
  g_free (bn_pix_casa_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_pix_tel), bn_pix_casa, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_casa);

  /*    ufficio
  */
  bn_pix_work = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_work_filename = gnome_pixmap_file ("./pixmaps/desktop.xpm");
  if (bn_pix_work_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_work), bn_pix_work_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "desktop.xpm");
  g_free (bn_pix_work_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_pix_tel), bn_pix_work, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_work);
  
  /*    fax
  */
  bn_pix_fax = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_fax_filename = gnome_pixmap_file ("./pixmaps/gnome-fax.png");
  if (bn_pix_fax_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_fax), bn_pix_fax_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "gnome-fax.png");
  g_free (bn_pix_fax_filename);
  gtk_box_pack_start (GTK_BOX (bn_box_pix_tel), bn_pix_fax, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_fax);
  
  /*    cellulare
  */
  bn_pix_cell = gtk_type_new (gnome_pixmap_get_type ());
  bn_pix_cell_filename = gnome_pixmap_file ("./pixmaps/gnome-cellulare.png");
  if (bn_pix_cell_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (bn_pix_cell), bn_pix_cell_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "gnome-cellulare.png");
  g_free (bn_pix_cell_filename);
  gtk_box_pack_start(GTK_BOX (bn_box_pix_tel), bn_pix_cell, TRUE, TRUE, 0);
  gtk_widget_show (bn_pix_cell);
   
  /*    Radio Button
  */
  bn_box_radio = gtk_vbox_new (TRUE, 5);
  gtk_box_pack_start (GTK_BOX (bn_box_dati_tel), bn_box_radio, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bn_box_radio), 5);
  gtk_widget_show (bn_box_radio);
  
  /*    radio casa: attivo di default
  */
  bn_radio_casa = apprub->radio_casa =
    gtk_radio_button_new_with_label (bn_box_radio_group,_("Casa"));
  apprub->radio_group = NULL;
  bn_box_radio_group = apprub->radio_group = 
    gtk_radio_button_group(GTK_RADIO_BUTTON (bn_radio_casa));
  gtk_box_pack_start(GTK_BOX (bn_box_radio), bn_radio_casa, FALSE, FALSE, 0);

  /* attivo il radio button di default e salvo
     i relativi dati nel record tel_num */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bn_radio_casa), TRUE);
  tel_num->tipo = TELEFONO_CASA;

  gtk_signal_connect(GTK_OBJECT(bn_radio_casa), "clicked",
		     GTK_SIGNAL_FUNC(radio_click),(TelNum*) tel_num);
  gtk_widget_show (bn_radio_casa);

  /*    radio lavoro
  */
  bn_radio_work =  apprub->radio_work = 
    gtk_radio_button_new_with_label(bn_box_radio_group,_("Lavoro"));
  bn_box_radio_group=gtk_radio_button_group (GTK_RADIO_BUTTON (bn_radio_work));
  gtk_box_pack_start (GTK_BOX (bn_box_radio), bn_radio_work, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bn_radio_work), "clicked",
		     GTK_SIGNAL_FUNC(radio_click),(TelNum*)tel_num);
  gtk_widget_show (bn_radio_work);
 
  /*    radio fax
  */
  bn_radio_fax =  apprub->radio_fax =
    gtk_radio_button_new_with_label (bn_box_radio_group,_("Fax"));
  bn_box_radio_group = gtk_radio_button_group(GTK_RADIO_BUTTON (bn_radio_fax));
  gtk_box_pack_start (GTK_BOX (bn_box_radio), bn_radio_fax, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bn_radio_fax), "clicked",
		     GTK_SIGNAL_FUNC(radio_click),(TelNum*)tel_num);
  gtk_widget_show (bn_radio_fax);
  
  /*    radio cellulare
  */
  bn_radio_cell =  apprub->radio_cell = 
    gtk_radio_button_new_with_label (bn_box_radio_group,
						   _("Cellulare"));
  bn_box_radio_group=gtk_radio_button_group(GTK_RADIO_BUTTON (bn_radio_cell));
  gtk_box_pack_start (GTK_BOX (bn_box_radio), bn_radio_cell, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bn_radio_cell), "clicked",
		     GTK_SIGNAL_FUNC(radio_click),(TelNum*) tel_num);
  gtk_widget_show (bn_radio_cell);

  /*    scrolled window clist numero telefono
  */
  bn_scroll_tel_clst = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (bn_box_dati_tel), 
		      bn_scroll_tel_clst, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (bn_scroll_tel_clst),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (bn_scroll_tel_clst);
  


  /*    **********************************
	CLIST  numeri telefono
	- due colonne, una contiene il numero telefonico, 
	l'altra contiene una icona rappresentante il numero
  */
  bn_tel_clista = apprub->tel_clista = gtk_clist_new (2);
  gtk_container_add (GTK_CONTAINER (bn_scroll_tel_clst), bn_tel_clista);
  gtk_clist_set_column_width (GTK_CLIST (bn_tel_clista), 0, 140);
  gtk_clist_set_column_width (GTK_CLIST (bn_tel_clista), 1, 100);
  gtk_clist_column_titles_show (GTK_CLIST (bn_tel_clista));

  gtk_clist_set_selection_mode(GTK_CLIST(bn_tel_clista),
			       GTK_SELECTION_SINGLE );
  gtk_signal_connect(GTK_OBJECT(bn_tel_clista), "select_row",
		     GTK_SIGNAL_FUNC(selezionata_riga), 
		     "tel");
  gtk_widget_show (bn_tel_clista);
  

  bn_clist_tel_lbl = gtk_label_new (_("Telefono"));
  gtk_clist_set_column_widget (GTK_CLIST (bn_tel_clista), 0, bn_clist_tel_lbl);
  gtk_widget_show (bn_clist_tel_lbl);
 
  bn_clist_quale_lbl = gtk_label_new (_("Descrizione"));
  gtk_clist_set_column_widget (GTK_CLIST (bn_tel_clista), 1, 
			       bn_clist_quale_lbl);
  gtk_widget_show (bn_clist_quale_lbl);
 


  /*   ******************************
       bottoni Telefono
  */
  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (bn_box_telefono), hbuttonbox1, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), 
			     GTK_BUTTONBOX_SPREAD);
  gtk_widget_show (hbuttonbox1);
  
  /*    aggiungi
  */
  bn_bot_tel_add = gtk_button_new_with_label (_("Aggiungi"));
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), bn_bot_tel_add);
  GTK_WIDGET_SET_FLAGS (bn_bot_tel_add, GTK_CAN_DEFAULT);
  registra_widget(bn_bot_tel_add, "tel add");
  gtk_widget_show (bn_bot_tel_add);
  
  /*    modifica
  */
  bn_bot_tel_edit = gtk_button_new_with_label (_("Modifica"));
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), bn_bot_tel_edit);
  GTK_WIDGET_SET_FLAGS (bn_bot_tel_edit, GTK_CAN_DEFAULT);
  gtk_widget_set_sensitive(bn_bot_tel_edit, FALSE);
  registra_widget(bn_bot_tel_edit, "tel edit");
  gtk_widget_show (bn_bot_tel_edit);
  
  /*    calcella
  */
  bn_bot_tel_canc = gtk_button_new_with_label (_("Cancella"));
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), bn_bot_tel_canc);
  GTK_WIDGET_SET_FLAGS (bn_bot_tel_canc, GTK_CAN_DEFAULT);
  gtk_widget_set_sensitive(bn_bot_tel_canc, FALSE);
  registra_widget(bn_bot_tel_canc, "tel canc");
  gtk_widget_show (bn_bot_tel_canc);
 
  bn_tel_lbl = gtk_label_new (_("Telefono"));
  gtk_notebook_set_tab_label(GTK_NOTEBOOK (notebook), 
		             gtk_notebook_get_nth_page(GTK_NOTEBOOK(notebook),
			     2), bn_tel_lbl);

  gtk_widget_show (bn_tel_lbl);


  /*    Collegamento dei bottoni alle funzioni di callback
  */

  /*    telefono aggiungi
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_tel_add), "clicked",
                      GTK_SIGNAL_FUNC (tel_add_clicked),
                      NULL);
  /*    telefono modifica
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_tel_edit), "clicked",
                      GTK_SIGNAL_FUNC (tel_edit_clicked),
                      NULL);
  /*    telefono cancella
  */
  gtk_signal_connect (GTK_OBJECT (bn_bot_tel_canc), "clicked",
                      GTK_SIGNAL_FUNC (tel_canc_clicked),
                      NULL);

}

void crea_note_notebook(GnomeRubrica *apprub, GtkWidget *notebook)
{
  
  GtkWidget *bn_box_note;
  GtkWidget *bn_note_lbl;
  GtkWidget *bn_scroll_note;
  GtkWidget *bn_text_note;
  GtkWidget *bn_note;         
  
  /*    Notebook Note
   */
  
  /*    box note
   */
  bn_box_note = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook), bn_box_note);
  gtk_widget_show (bn_box_note);
  
  /*    creo l'etichetta Note e la impacchetto
   */
  bn_note_lbl = gtk_label_new (_("Note:"));
  gtk_box_pack_start (GTK_BOX (bn_box_note), bn_note_lbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (bn_note_lbl), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (bn_note_lbl), TRUE);
  gtk_misc_set_alignment (GTK_MISC (bn_note_lbl), 0.01, 0.5);
  gtk_misc_set_padding (GTK_MISC (bn_note_lbl), 0, 4);
  gtk_widget_show (bn_note_lbl);
  
  /*    scrolled window per la casella di testo
   */
  bn_scroll_note = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (bn_box_note), bn_scroll_note, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (bn_scroll_note), 
				  GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_widget_show (bn_scroll_note);
  
  /*    casella di testo
        - acquisisce le note
  */
  bn_text_note = apprub->note = gtk_text_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (bn_scroll_note), bn_text_note);
  gtk_text_set_editable (GTK_TEXT (bn_text_note), TRUE);
  gtk_widget_show (bn_text_note);
  
  bn_note = gtk_label_new (_("Note"));
  gtk_notebook_set_tab_label(GTK_NOTEBOOK(notebook), 
			     gtk_notebook_get_nth_page(GTK_NOTEBOOK 
			     (notebook),3), bn_note);
  gtk_widget_show (bn_note);  
}


void crea_form_acquisisci (GnomeRubrica *apprub)
{
  GtkWidget *dialog_vbox1;
  GtkWidget *dialog_action_area1;
  GtkWidget *form_acquisisci;
  GtkWidget *notebook;

  GtkWidget *form_ok_bt;
/*  GtkWidget *form_applica_bt; */
  GtkWidget *form_annulla_bt;

  TipoRubrica *rub;
  GList* tmp_lst;

  /* se la form non  mai stata creata 
     la disegno, altrimenti esco dalla funzione
  */
  if (!apprub->form_done)
    apprub->form_done = TRUE; 
  else    
    return;


  /*    form di acquisizione: finestra di dialogo
   */
  form_acquisisci = apprub->form = 
    gnome_dialog_new (_("Aquisizione dati"), NULL);

  GTK_WINDOW (form_acquisisci)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (form_acquisisci), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (form_acquisisci), FALSE, FALSE, FALSE);
  gnome_dialog_close_hides (GNOME_DIALOG (form_acquisisci), TRUE);
  registra_widget(form_acquisisci, "form");
  
  /*    seleziona il box verticale della finestra di dialogo
   */
  dialog_vbox1 = GNOME_DIALOG (form_acquisisci)->vbox;
  registra_widget(dialog_vbox1, "vbox form");
  gtk_widget_show (dialog_vbox1);

  /*    crea il notebook da inserire nella finestra
   */
  notebook = gtk_notebook_new ();
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook, TRUE, TRUE, 0);
  registra_widget(notebook, "notebook");
  gtk_widget_show (notebook);
  
  crea_dati_personali_notebook(apprub, notebook);
  crea_rete_notebook(apprub, notebook);
  crea_telefono_notebook(apprub, notebook);
  crea_note_notebook(apprub, notebook);
  
  /*    area bottoni form:
	- ok
	- cancella
  */
  dialog_action_area1 = GNOME_DIALOG (form_acquisisci)->action_area;
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1),
			     GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  /*    bottone ok
  */
  gnome_dialog_append_button (GNOME_DIALOG (form_acquisisci), 
			      GNOME_STOCK_BUTTON_OK);
  form_ok_bt = g_list_last (GNOME_DIALOG (form_acquisisci)->buttons)->data;
  GTK_WIDGET_SET_FLAGS (form_ok_bt, GTK_CAN_DEFAULT);

//  if (!editato)
//    gtk_widget_set_sensitive(GTK_WIDGET(form_ok_bt),FALSE);
  gtk_widget_show (form_ok_bt);
 
  /*    bottone applica
   */
  /*
    gnome_dialog_append_button (GNOME_DIALOG (form_acquisisci), 
    GNOME_STOCK_BUTTON_APPLY);
    form_applica_bt = g_list_last(GNOME_DIALOG (form_acquisisci)->buttons)->data;
    GTK_WIDGET_SET_FLAGS (form_applica_bt, GTK_CAN_DEFAULT);
    if (!editato)
    gtk_widget_set_sensitive(GTK_WIDGET(form_applica_bt),FALSE);
    gtk_widget_show (form_applica_bt);
  */
  
  /*    bottone annulla
   */
  gnome_dialog_append_button (GNOME_DIALOG (form_acquisisci), 
			      GNOME_STOCK_BUTTON_CANCEL);
  form_annulla_bt=g_list_last (GNOME_DIALOG (form_acquisisci)->buttons)->data;
  GTK_WIDGET_SET_FLAGS (form_annulla_bt, GTK_CAN_DEFAULT);
  gtk_widget_show (form_annulla_bt);
  
  gtk_widget_show (dialog_action_area1);


  /* -------------------------------------------------------------
     Bottoni FORM
     -------------------------------------------------------------
  */
 
  /*    form OK
  */
  gtk_signal_connect (GTK_OBJECT (form_ok_bt), "clicked",
                      GTK_SIGNAL_FUNC (prendi_dati_cb
				       /*on_form_applica_bt_clicked*/),
                      apprub);
  gtk_signal_connect(GTK_OBJECT(form_ok_bt), "clicked",
		     GTK_SIGNAL_FUNC(chiudi_form),
		     (GtkWidget*) apprub->form);
  /*    form APPLICA
  */
  /*
    gtk_signal_connect (GTK_OBJECT (form_applica_bt), "clicked",
    GTK_SIGNAL_FUNC (on_form_applica_bt_clicked),
    (TipoRubrica*) rub);
  */

  /*    form ANNULLA
   */
  gtk_signal_connect (GTK_OBJECT (form_annulla_bt), "clicked",
                      GTK_SIGNAL_FUNC (chiudi_form),
		      (GtkWidget*) apprub->form);
  
  tmp_lst = g_list_first(lista);
  rub = (TipoRubrica*) tmp_lst->data;
  credits(GTK_CLIST(apprub->clista), rub);
}

void credits(GtkCList *clist, TipoRubrica *tmp)
{
  gchar *item[3];
  
  item[0] = g_strdup(tmp->nome_scheda);
  item[1] = g_strdup(tmp->nome);
  item[2] = g_strdup(tmp->cognome);
  
  gtk_clist_append(GTK_CLIST(clist), item);
}


void crea_box_bottoni(GtkWidget *box)
{
  GtkWidget *hbox_bot;
  GtkWidget *separatore;
  GtkWidget *vbotbox;
  
  /* GtkWidget *bot_trova; */

  hbox_bot = gtk_hbox_new(FALSE,2);
  gtk_box_pack_start(GTK_BOX(box),hbox_bot,FALSE, TRUE, 2);
  gtk_widget_show(hbox_bot);
  
  separatore = gtk_vseparator_new();
  gtk_box_pack_start(GTK_BOX(hbox_bot), separatore, TRUE,TRUE, 3);
  gtk_widget_show(separatore);
  
  vbotbox = gtk_vbutton_box_new();
  gtk_button_box_set_layout (GTK_BUTTON_BOX(vbotbox),GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_child_size(GTK_BUTTON_BOX(vbotbox),85,27);
  gtk_button_box_set_child_ipadding(GTK_BUTTON_BOX(vbotbox),7,0);
  gtk_vbutton_box_set_spacing_default(10);
  gtk_box_pack_start(GTK_BOX(hbox_bot), vbotbox, TRUE, TRUE, 0);
  gtk_widget_show(vbotbox);
  
  /*   ==========================
       ==========================
       
       FUNZIONE TROVA
       SPOSTARE NELLA TOOLBAR
       
       ==========================
       ==========================
  */
  
  /*
    bot_trova = gtk_button_new_with_label("Trova");
    gtk_container_add(GTK_CONTAINER(vbotbox), bot_trova);
    gtk_signal_connect(GTK_OBJECT(bot_trova),"clicked",
    GTK_SIGNAL_FUNC(on_trova_clicked),NULL);
    gtk_widget_show(bot_trova);
  */
}


