#include <gnome.h>
#include "rubrica.h"
#include "util.h"

extern GList *registro;
extern GnomeRubrica *apprub;
extern gint tot;


void registra_widget(gpointer ptr, gchar *nome)
{
  RegElem *reg;
  
  reg = (RegElem*) g_malloc (sizeof(RegElem));

  reg->ptr = (GtkWidget *) ptr;
  reg->nome = strdup(nome);
  
  gtk_widget_set_name(ptr, nome);
  
  registro = g_list_append(registro, reg);
}

GtkWidget *leggi_registro(gchar *nome)
{
  RegElem *reg;
  gchar *buffer;
  GList *alias;
  gboolean trovato = FALSE;

  alias = registro;
  reg = (RegElem *) alias->data;
  buffer = g_strdup(reg->nome);

  while(!trovato && alias != NULL)
    {      
      if (strcmp(nome, buffer) == 0)
	trovato = TRUE;
      else {
	g_free(buffer);
	alias = alias->next;
	reg = (RegElem *) alias->data;
	buffer = g_strdup(reg->nome);
      }
    }

  g_free(buffer);

  return (GtkWidget *)reg->ptr;
}

void entry_modificata(GtkWidget *wid, gpointer data)
{
  GtkWidget *bot;
  gchar *tipo_lista = data;
  
  if (strcmp(tipo_lista, "web") == 0)
    bot = (GtkWidget *) leggi_registro("web edit");
  if (strcmp(tipo_lista, "mail") == 0)
    bot = (GtkWidget *) leggi_registro("mail edit");
  if (strcmp(tipo_lista, "tel") == 0)
    bot = (GtkWidget *) leggi_registro("tel edit");
   
  gtk_widget_set_sensitive(GTK_WIDGET(bot), TRUE);
}

void radio_modificati(GtkWidget *wid, gpointer data)
{
  GtkWidget *radio;
  GtkWidget *bot;
  
  switch ((gint) data)
    {
    case TELEFONO_CASA:
      radio = apprub->radio_casa;
      break;

    case TELEFONO_UFFICIO:
      radio = apprub->radio_work;
      break;

    case TELEFONO_FAX:
      radio = apprub->radio_fax;
      break;

    case TELEFONO_CELLULARE:
      radio = apprub->radio_cell;
      break;

    default:
      radio = apprub->radio_casa;       
      break;	    
    }
  
  bot = (GtkWidget *) leggi_registro("tel edit");
  gtk_widget_set_sensitive(GTK_WIDGET(bot), TRUE);
  
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
}

/*  funzioni particolari
    callback web, mail, telefono
*/

gint sensibilizza_bottoni(gchar *nome1, gchar *nome2, gboolean stato)
{
  GtkWidget *bot[2] = {NULL, NULL};

  if (nome1 != NULL)
    bot[0] = (GtkWidget *) leggi_registro(nome1);
  if (nome2 != NULL)
    bot[1] = (GtkWidget *) leggi_registro(nome2);

  if (bot[0] == NULL)
    return -1;
  else
    gtk_widget_set_sensitive(GTK_WIDGET(bot[0]), stato);

  if (bot[1] == NULL)
    return -1;
  else
    gtk_widget_set_sensitive(GTK_WIDGET(bot[1]), stato);   

  return 0;
}

void pulisci_entry(GnomeRubrica *apprub)
{
  gtk_entry_set_text(GTK_ENTRY(apprub->scheda),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->nome),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->cognome),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->prof),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->via),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->num),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->citta),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->prov),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->cap),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->stato),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->web),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->mail),"");
  gtk_entry_set_text(GTK_ENTRY(apprub->tel),"");
  gtk_editable_delete_text(GTK_EDITABLE(apprub->note), 0, -1);
}

tipo_telefono determina_tipo_telefono(gchar *buffer)
{
  gint tipo;
  
  if (strcmp(buffer, "0") == 0)
    tipo = TELEFONO_CASA;

  if (strcmp(buffer, "1") == 0)
    tipo = TELEFONO_UFFICIO;
  
  if (strcmp(buffer, "2") == 0)
    tipo = TELEFONO_FAX;
  
  if (strcmp(buffer, "3") == 0)
    tipo = TELEFONO_CELLULARE;

  return (tipo_telefono) tipo;
}

tipo_telefono get_tipo_telefono(gchar *buffer)
{
  gint tipo;

  if (strcmp(buffer, "Telefono Casa") == 0)
    tipo = 0;

  if (strcmp(buffer, "Telefono Ufficio") == 0)
    tipo = 1;
  
  if (strcmp(buffer, "Telefono Fax") == 0)
    tipo = 2;
  
  if (strcmp(buffer, "Telefono Cellulare") == 0)
    tipo = 3;

  return (tipo_telefono) tipo;
}

void visualizza_dati(gchar *item[16][3])
{
  gint i;
  
  gtk_clist_clear(GTK_CLIST(apprub->clist_dati));

  for (i=0; i<10; i++)
    gtk_clist_insert(GTK_CLIST(apprub->clist_dati),i, item[i]);
}

void mostra_lista(GList *lst)
{
  /* devo definire item composto da 14 elementi, in quanto la lista ha 14 colonne */
  gchar *item[14] =
  { NULL, NULL, NULL, NULL, NULL, 
    NULL, NULL, NULL, NULL, NULL,
    NULL, NULL, NULL, NULL,  };

  TipoRubrica *tr;
  GList *alias;
  GtkWidget *clist;

  alias = lst;
  clist = apprub->clista;
  
  gtk_clist_clear(GTK_CLIST(apprub->clista));

  while (alias != NULL)
    {
      tr = alias->data;

      item[0] = g_strdup(tr->nome_scheda);
      item[1] = g_strdup(tr->nome);
      item[2] = g_strdup(tr->cognome); 
       
      gtk_clist_append(GTK_CLIST(clist), item);	       
    
      alias = alias->next;
    }

  gtk_progress_set_value(GTK_PROGRESS(apprub->progressbar), (gfloat)tot);
  gtk_progress_set_show_text(GTK_PROGRESS(apprub->progressbar), TRUE); 
}

gpointer estrai_dato(gchar *buffer, Token *token)
{  
  gchar *tkbuf;
  gchar *dato;
  
  tkbuf = strdup(buffer);
  strtok(tkbuf, "=");
  dato = NULL;

  *token = get_token(tkbuf);

  switch ((gint) *token)
    {
    case CANCELLABILE:
    case EDITABILE:
    case SCHEDA:
    case NOME:
    case COGNOME:   
    case PROFESSIONE:
    case VIA:
    case NUMERO:
    case CITTA:
    case PROVINCIA:
    case CAP:
    case STATO:
    case WEB:
    case MAIL:
    case TELEFONO:
    case TIPO:
    case LEN_NOTE:
    case NOTE:
      while (*buffer != '=')
	buffer++;
      
      dato = strdup(++buffer);
      break;
    case NOTE_NULLE:
      break;
    default:
      break;
    } 
  free(tkbuf);
  
  return (gchar *)dato;
}

Token get_token(gchar *tkbuf) 
{
  if (strcmp(tkbuf, "BEGIN") == 0)
    return BEGIN;
  if (strcmp(tkbuf, "BEGIN_ITEM") == 0)
    return BEGIN_ITEM;
  if (strcmp(tkbuf, "CANCELLABILE") == 0)
    return CANCELLABILE;
  if (strcmp(tkbuf, "EDITABILE") == 0)
    return EDITABILE;
  if (strcmp(tkbuf, "SCHEDA") == 0)
    return SCHEDA;
  if (strcmp(tkbuf, "NOME") == 0)
    return NOME;
  if (strcmp(tkbuf, "COGNOME") == 0)
    return COGNOME;
  if (strcmp(tkbuf, "PROFESSIONE") == 0)
    return PROFESSIONE;
  if (strcmp(tkbuf, "VIA") == 0)
    return VIA;
  if (strcmp(tkbuf, "NUMERO") == 0)
    return NUMERO;
  if (strcmp(tkbuf, "CITTA'") == 0)
    return CITTA;
  if (strcmp(tkbuf, "PROVINCIA") == 0)
    return PROVINCIA;
  if (strcmp(tkbuf, "CAP") == 0)
    return CAP;
  if (strcmp(tkbuf, "STATO") == 0)
    return STATO;
  if (strcmp(tkbuf, "WEB") == 0)
    return WEB;
  if (strcmp(tkbuf, "MAIL") == 0)
    return MAIL;
  if (strcmp(tkbuf, "TELEFONO") == 0)
    return TELEFONO;
  if (strcmp(tkbuf, "TIPO") == 0)
    return TIPO;
  if (strcmp(tkbuf, "NOTE") == 0)
    return NOTE;
  if (strcmp(tkbuf, "LEN_NOTE") == 0)
    return LEN_NOTE;  
  if (strcmp(tkbuf, "NOTE_NULLE") == 0)
    return NOTE_NULLE;  
  if (strcmp(tkbuf, "END_ITEM") == 0)
    return END_ITEM;
  if (strcmp(tkbuf, "END") == 0)
    return END;
  
  return SCONOSCIUTO; 
}


void vedi_elemento_debug(TipoRubrica *i)
{
  GList *alias;
  gint n;

  g_print("\n\n\ndati contenuti nell'elemento");

  g_print("\nNome scheda: %s", i->nome_scheda);
  g_print("\nNome: %s", i->nome);
  g_print("\nCognome: %s", i->cognome);
  g_print("\nProfesione: %s", i->professione);
  g_print("\nVia: %s", i->via);
  g_print("\nNumero: %s", i->numero);
  g_print("\nCitt: %s", i->citta);
  g_print("\nProvincia: %s", i->provincia);
  g_print("\nCap: %s", i->cap);
  g_print("\nStato: %s", i->stato);

  alias = i->web;
  n=1;
  while(alias != NULL)
    {  
      g_print("\nWeb numero %d: %s",n, (gchar*) alias->data);
      alias=alias->next;
      n++;
    }

  alias = i->mail;
  n=1;
  while(alias != NULL)
    {
      g_print("\nMail numero %d: %s",n,(gchar*) alias->data);
      alias=alias->next;
      n++;
    }

  alias = i->telefono;
  n=1;
  while(alias != NULL)
    {
      TelNum *tel;
      
      tel = (TelNum*) alias->data;
      g_print("\nTelefono numero: %s\nTipo: %d", tel->numero, tel->tipo);
      alias = alias->next;
      n++;
    }
  
  g_print("\nNote: %s", i->note);
}

gint mostra_note(GtkWidget *clist, gint riga, gchar *str)
{
  gchar *testo[1][3] ={ 
    {"Note:", NULL, NULL} 
  };
  gchar *buffer;
  gint i = 0;
  gint n = 0;
  gint len;

  if (str == NULL)
    return -1;

  len = strlen(str);
  buffer = g_malloc(len);
  
  while (n <= len) {
    if (str[n] != '\n') {
      buffer[i++] = str[n++];
    }
    else {
      buffer[i] = '\000';          
      testo[0][1] = strdup(buffer);
      gtk_clist_insert(GTK_CLIST(clist), riga, testo[0]);         
      testo[0][0] = "";
      riga++;
      i = 0;
      n++;
    }
  }
  
  g_free(buffer);

  return 0;
}
